% Start acer.m ------------------------------------------------------------

clear all
load('ILMdata')
run('separate');

% User inputs:
start=;
stop=;
LX=;
N_k=; %Highest order of the acer function to be included

% Threshold:
threshold=25; %[kN] >= 25. 25 is default in the data set
if threshold>25
a=1;
LX_copy=LX;
clearvars LX
for i=1:length(LX_copy)
    if LX_copy(i,2)>threshold
        LX(a,:)=LX_copy(i,:);
        a=a+1;
    end
end
end

i=1;
while LX(i,1)<time(start) %finds start point "i" of interval
    i=i+1;
end
j=i;
l_LX=length(LX);
while LX(j,1)<time(stop) && j<l_LX %finds stop point "j" of interval
    j=j+1;
end
dataset=LX(i:j,2);

eta=sort(dataset); %load vector eta
N=length(dataset); 
ACER=zeros(N,N_k); %acer function values
P=zeros(N,N_k); %extreme value distribution for large values of eta
rho=zeros(N,N_k); %Weight factor used in optimization of fitted curve
plusminus=zeros(N,N_k); %half of the length of the confidence interval


for k=1:N_k %each order of the ACER function
for r=1:N %Calculating points for element in "dataset"

if k==1
    q=sort(dataset); %Used for calculating P(etta)
    
    i=round(N/2); %i: number of elements in "dataset" <= eta
    numerator=0.5;
    step=2;%Given a number >1
    while N*numerator>1 %Continues as long as the step length is > 1
        numerator=numerator/2;
        if q(i)<eta(r)
            i=round(i+N*numerator);
        elseif q(i)>eta(r)
            i=round(i-N*numerator);
        else %q(i)==etta(r)
            break
        end
    end
    if q(i)>eta(r) %Correctin for possible numerical errors
        i=i-1;
    end
    alpha_1j=(N-i)/N;%1-i/(N+1);
    
    ACER(r,k)=alpha_1j; %=(1/(N-k+1))*N*alpha_1j
    P(r,k)=exp(-N*alpha_1j);
   
    
    % Calculate a_kj for each element:
    else %if k is larger than 1
    a_kj=zeros(N,1);
    check=1; 
    for j=k:N
        for i=(j-k+1):j-1
            if dataset(i)>eta(r) %Requirement: the previous loads...
            %being smaller than eta
            check=0; %fails
            break
            end
        end
        if dataset(j)<=eta(r) %Requirement: load is larger than eta
            check=0; %fails
        end
        if check==1 %All requirements are fulfilled.
            a_kj(j)=1;
        end
    check=1;
    end

    epsilon_hat=(1/(N-k+1))*sum(a_kj(k:end));
    ACER(r,k)=epsilon_hat;
    P(r,k)=exp(-sum(a_kj(k:end)));
end
plusminus(r,k)=(ACER(r,k)*1.96)/sqrt((N-k+1)*ACER(r,k));
rho(r,k)=(log(ACER(r,k)+plusminus(r,k))-log(ACER(r,k)-plusminus(r,k)))^-2;
end
end

%Confidence interval (lower and upper bound)
CIminus=ACER-plusminus;
CIplus=ACER+plusminus;

figure1 = figure;
% Create axes
axes1 = axes('Parent',figure1);
hold(axes1,'on');

% Create multiple lines using matrix input to stairs
stairs(eta,ACER,'Parent',axes1);

xlabel({'$\eta$ [kN]'},'Interpreter','latex')
ylabel({'ACER($\eta$,k)'},'Interpreter','latex')
legend({'k=1','k=2','k=3','k=4','k=5'});

box(axes1,'on');
% Set the remaining axes properties
set(axes1,'YMinorTick','on','YScale','log');

% End acer.m --------------------------------------------------------------