% Start confidence_int.m --------------------------------------------------

run('bootstrapping')
conf_int=0.95; %Confidence level

% Select first or second parameter (see param.m):
prompt = 'Input: "1" for parameter 1, "2" parameter 2  ';
par_inp = input(prompt);

param=sort(param);
% Element in "param" where the confidence interval starts:
start_int=floor((1-conf_int)/2*length(param));
% Element in "param" where the confidence interval ends:
end_int=ceil((0.5+0.5*conf_int)*length(param));

% Start and end values of the confidence interval:
CI_min=param(start_int,par_inp);
CI_plus=param(end_int,par_inp);

% Number of stems in stem plot:
n_stem=40;

% "Width" of each stem:
delta=(param(end,par_inp) - param(1,par_inp))/(n_stem-1); 

% x-values for stem plot:
x_stem=param(1,par_inp)+delta:delta:param(end,par_inp);
% y-values for stem plot (initially set to 0):
y_stem=zeros(n_stem-1,1); 

y_stem(1)=1; %quick-fix
% Calculate nr of elements from param within each interval (stem):
for i=2:length(param)
    %Find element nr in y_stem:
    find_nr=ceil((param(i,par_inp)-param(1,par_inp))/delta);
    y_stem(find_nr)=y_stem(find_nr)+1;
    if find_nr>length(y_stem)
        find_nr=find_nr-1;
    end
end

% Plot stem plot of parameters for bootstrapped samples, and conf. int.:
stem(x_stem,y_stem,'k')
hold on
title('Bootstrapped samples')
xlabel('$\theta$','Interpreter','latex')
ylabel('Number of occurrences')
vline=get(gca,'ylim');
par_hat=plot([theta_hat,theta_hat],vline,'--k'); %Edit parameter
confint=plot([CI_min,CI_min],vline,'--r');
plot([CI_plus,CI_plus],vline,'--r');
%legend(par_hat,{'$\hat{\theta}$'},'Interpreter','latex');
legend([par_hat,confint],{'$\hat{\theta}$',...
    '$95 \%$ confidence interval'},'Interpreter','latex');

% End confidence_int.m ----------------------------------------------------