clear all
% Start hv_xmax.m ---------------------------------------------------------
load('ILMdata')
run('separate_s');

ss=[7680    7743    
7770	7830        
8167	8203        
8316	8334        
10942	11002       
11002   11032       
15618	15678       
15720	15762       
11058   11123];     

q=1;

for jj=1:8
    clearvars k theta x_max_hour v h
    z=0;
    if jj==1
    LX=L1; elseif jj==2 LX=L2; elseif jj==3 LX=L3; elseif jj==4 LX=L4; 
    elseif jj==5 LX=L5; elseif jj==6 LX=L6; elseif jj==7 LX=L7; else LX=L8;
    end
%LX=L1; %User input: define sensor
% prompt = 'Input: 1 for exponential distribution, 2 for Log-normal,...
%3 for Gumbel, 4 for Weibull, 5 for 3-parameter-exponential  ';
% distr = input(prompt);

for ii=1:length(ss)
    start=ss(ii,1);
    stop=ss(ii,2);

i=1;
while LX(i,1)<time(start) %finds start point "i" of interval
    i=i+1;
end
j=i;
l_LX=length(LX);
while LX(j,1)<time(stop) && j<l_LX %finds stop point "j" of interval
    j=j+1;
end

dataset=LX(i:j,2);

v_ss(ii)=mean(data(ss(ii,1):ss(ii,2),3)); %speed over ground
h_ss(ii)=mean(data(ss(ii,1):ss(ii,2),12)); %ice thickness

if length(dataset)>=1
z=z+1;
    
% p_i=1:length(dataset);
% p_i=p_i/(length(dataset)+1);

dataset=sort(dataset);
dataset=dataset-25; %Correction for threshold

thetak=wblfit(dataset); %Parameter estimation for Weibull using MLE
k(ii)=thetak(2); %Weibull
theta(ii)=thetak(1);

n_hour=60*length(dataset)/((stop-start)*0.5);%loads per hour
x_max_hour(z)=theta(ii)*(-log(1/n_hour))^(1/k(ii)) + 25;

v(z)=v_ss(ii); %speed over ground
h(z)=h_ss(ii); %ice thickness
end

end
v_tot(q:q+length(v)-1)=v;
h_tot(q:q+length(h)-1)=h;
max_tot(q:q+length(x_max_hour)-1)=x_max_hour;
q=q+z;

figure(1); %Ice thickness
s_h(jj)=scatter(h,x_max_hour,'*');
title('Most probable largest 1 hour load vs mean ice thickness')
xlabel('Mean ice thickness [m]')
ylabel('Most probable largest 1 hour load [kN]')
hold on
ind_fit_h=lsline; %plot the fitted line
mc_h=polyfit(h,x_max_hour,1);
m_h(jj)=mc_h(1); %slope
c_h(jj)=mc_h(2); %ordinate interception

figure(2); %Speed over ground
s_v(jj)=scatter(v,x_max_hour,'*');
title('Most probable largest 1 hour load vs mean speed over ground')
xlabel('Mean speed over ground [m/s]')
ylabel('Most probable largest 1 hour load [kN]')
hold on
ind_fit_v=lsline; %plot the fitted line
mc_v=polyfit(v,x_max_hour,1);
m_v(jj)=mc_v(1); %slope
c_v(jj)=mc_v(2); %ordinate interception

end

figure(1)
ab_h=polyfit(h_tot,max_tot,1);
hline=get(gca,'xlim');
y_tot=[ab_h(2)+ab_h(1)*hline(1),ab_h(2)+ab_h(1)*hline(2)];
fit=plot(hline,y_tot,'k','LineWidth',1.5);
grid on
%legend([s_h,ind_fit_v(1),fit],{'L1','L2','L3','L4','L5','L6','L7','L8',...
    %'Least square fit to each sensor','Least square fit to all data points'})

figure(2)
ab_v=polyfit(v_tot,max_tot,1);
hline=get(gca,'xlim');
y_tot=[ab_v(2)+ab_v(1)*hline(1),ab_v(2)+ab_v(1)*hline(2)];
fit=plot(hline,y_tot,'k','LineWidth',1.5);
legend([s_v,ind_fit_h(1),fit],{'L1','L2','L3','L4','L5','L6','L7','L8',...
    'Least square fit to each sensor','Least square fit to all data points'})
grid on

%figure(3)=
