clear all
load('ILMdata')
run('separate_s');

ss=[%7680    7743    %1
7770	7830        %2
%8167	8203        %3
%8316	8334        %4
10942	11002       %5
11056   11086
%11002   11032       %6
%15618	15678       %7
%15720	15762       %8
11058   11123];     %9

q=1;

for jj=1:8
    clearvars k theta x_max_hour v h
    z=0;
    if jj==1
    LX=L1; elseif jj==2 LX=L2; elseif jj==3 LX=L3; elseif jj==4 LX=L4; 
    elseif jj==5 LX=L5; elseif jj==6 LX=L6; elseif jj==7 LX=L7; else LX=L8;
    end
%LX=L1; %User input: define sensor
% prompt = 'Input: 1 for exponential distribution, 2 for Log-normal,...
%3 for Gumbel, 4 for Weibull, 5 for 3-parameter-exponential  ';
% distr = input(prompt);

for ii=1:length(ss)
    start=ss(ii,1);
    stop=ss(ii,2);

i=1;
while LX(i,1)<time(start) %finds start point "i" of interval
    i=i+1;
end
j=i;
l_LX=length(LX);
while LX(j,1)<time(stop) && j<l_LX %finds stop point "j" of interval
    j=j+1;
end

dataset=LX(i:j,2);

v_ss(ii)=mean(data(ss(ii,1):ss(ii,2),3)); %speed over ground
h_ss(ii)=mean(data(ss(ii,1):ss(ii,2),12)); %ice thickness

if length(dataset)>=1
z=z+1;
    
% p_i=1:length(dataset);
% p_i=p_i/(length(dataset)+1);

dataset=sort(dataset);
dataset=dataset-25; %Correction for threshold

thetak=wblfit(dataset); %Parameter estimation for Weibull using MLE
k(ii)=thetak(2); %Weibull
theta(ii)=thetak(1);

n_hour=60*length(dataset)/((stop-start)*0.5);%loads per hour
x_max_hour(z)=theta(ii)*(-log(1/n_hour))^(1/k(ii)) + 25;

v(z)=v_ss(ii); %speed over ground
h(z)=h_ss(ii); %ice thickness
end

end
v_tot(q:q+length(v)-1)=v;
h_tot(q:q+length(h)-1)=h;
max_tot(q:q+length(x_max_hour)-1)=x_max_hour;
q=q+z;

figure(1); %Ice thickness
s_h(jj)=scatter(h,x_max_hour,'*');
title('Most probable largest 1 hour load vs mean ice thickness')
xlabel('Mean ice thickness [m]')
ylabel('Most probable largest 1 hour load [kN]')
hold on
mc_h=polyfit(h,x_max_hour,1);
m_h(jj)=mc_h(1); %slope
c_h(jj)=mc_h(2); %ordinate interception

figure(2); %Speed over ground
s_v(jj)=scatter(v,x_max_hour,'*');
title('Most probable largest 1 hour load vs mean speed over ground')
xlabel('Mean speed over ground [m/s]')
ylabel('Most probable largest 1 hour load [kN]')
hold on
mc_v=polyfit(v,x_max_hour,1);
m_v(jj)=mc_v(1); %slope
c_v(jj)=mc_v(2); %ordinate interception

end
m1=mean([max_tot(2),max_tot(6),max_tot(10),max_tot(14),max_tot(18),max_tot(22),max_tot(26),max_tot(30)]);
m2=mean([max_tot(4),max_tot(8),max_tot(12),max_tot(16),max_tot(20),max_tot(24),max_tot(28),max_tot(32)]);
m3=mean([max_tot(1),max_tot(5),max_tot(9),max_tot(13),max_tot(17),max_tot(21),max_tot(25),max_tot(29)]);
m4=mean([max_tot(3),max_tot(7),max_tot(11),max_tot(15),max_tot(19),max_tot(23),max_tot(27),max_tot(31)]);

figure(1)
ab_h=polyfit([h_tot(2) h_tot(4)],[m1 m2],1)
plot([h_tot(2) h_tot(4)],[m1 m2],'k','LineWidth',1.5)
%hline=get(gca,'xlim');
%y_tot=[ab_h(2)+ab_h(1)*hline(1),ab_h(2)+ab_h(1)*hline(2)];
%plot(hline,y_tot,'k','LineWidth',1.5);

ab_h=polyfit([h_tot(1) h_tot(3)],[m3 m4],1)
fit1=plot([h_tot(1) h_tot(3)],[m3 m4],'k','LineWidth',1.5);
%hline=get(gca,'xlim');
%y_tot=[ab_h(2)+ab_h(1)*h_tot(1),ab_h(2)+ab_h(1)*h_tot(3)];
%fit1=plot([h_tot(1) h_tot(3)],y_tot,'k','LineWidth',1.5);

grid on
legend([s_h,fit1],{'L1','L2','L3','L4','L5','L6','L7','L8',...
    'Least square fits to each pair of data points'})

figure(2)
ab_v=polyfit(v_tot,max_tot,1);
hline=get(gca,'xlim');
y_tot=[ab_v(2)+ab_v(1)*hline(1),ab_v(2)+ab_v(1)*hline(2)];
fit2=plot(hline,y_tot,'k','LineWidth',1.5);
legend([s_v,fit2],{'L1','L2','L3','L4','L5','L6','L7','L8',...
    'Least square fit to all data points'})
grid on

