% Start parameters.m ------------------------------------------------------

if exist('no_plot','var')==0  %False if bootstrapped samples are analyzed
run('prob_paper')
end
N=length(dataset);
if distr==5 %For Kolmogorov-Smirnov test. Parameters not calculated here
return
end

% Based on probability paper:
if method==1
lambda=m; %Exponential
sigma=1/m; %Log-normal
mu=-sigma*c; %Log-normal
beta=1/m; %Gumbel
alpha=-beta*c; %Gumbel
k=m; %Weibull
theta=exp(-c/k); %Weibull

% Maximum Likelihood Estimate (MLE):
elseif method==2
lambda=1/mean(dataset); %Exponential
mu=sum(log(dataset))/N; %Log-normal
sigma=sqrt(sum((log(dataset)-mu).^2)/N); %Log-normalexp
alphabeta=evfit(-dataset); %Parameter estimation for Gumbel using MLE
alpha=-alphabeta(1); %Gumbel
beta=alphabeta(2); %Gumbel
thetak=wblfit(dataset); %Parameter estimation for Weibull using MLE
k=thetak(2); %Weibull
theta=((1/N)*sum(dataset.^k))^(1/k); %Weibull
%***********************************************************
end

%Relevant for bootstrapped samples:
if distr==1 %Exponential
     parameter1=lambda;
     parameter2=0;
     %Most probable largest value during the evaluated time series:
     x_max=(-log(1/N)/lambda) +25; %Corrected for the threshold
elseif distr==2%Log-normal
     parameter1=sigma;
     parameter2=mu;
     x_max=exp(sigma*norminv(1-1/N) + mu) + 25;
elseif distr==3%Gumbel
     parameter1=beta;
     parameter2=alpha;
     x_max=alpha - beta*log(-log(1-1/N)) + 25;
elseif distr==4%Weibull
     parameter1=k;
     parameter2=theta;
     x_max=theta*(-log(1/N))^(1/k) + 25;
end

% End parameters.m --------------------------------------------------------