%Similar speed
maxi1=[135.6 142.1 155.6 172.8 153.7 167.3 168.6 159]; %set 5
maxj1=[176.9 172.6 211.7 196.7 175.6 181.8 186.3 141.8]; %set 13

maxi2=[162.3 131.4 214.0 245.1 243.2 270.3 171.9]; %set 2
maxj2=[191.4 154.8 227.9 150.4 152.1 206.6 142]; %set 7

hi1=0.82; %set 5
hj1=1.00; %set 13
hi2=1.13; %set 2
hj2=0.99; %set 7

relx1=maxi1./maxj1;
relx2=maxi2./maxj2;
relh1=hi1/hj1;
relh2=hi2/hj2;
x1=relh1*ones(length(maxi1),1);
x2=relh2*ones(length(maxi2),1);

figure(1)
s1=scatter(x1,relx1,'+k');% 95% Confidence Interval: 0.8781  0.0818 (0.796 to 0.96)
hold on
s2=scatter(x2,relx2,'*k');% 95% Confidence Interval: 1.1976  0.248 (0.95 to 1.45)
s3=scatter(x1(1),mean(relx1),'kx','SizeData',300);
s4=scatter(x2(1),mean(relx2),'kx','SizeData',300);
title('Similar speed over ground')
xlabel('$\mu_{ice,i}/\mu_{ice,j}$','FontSize',14,'Interpreter','latex')
ylabel('$\hat{x}_{max,1h,i}/\hat{x}_{max,1h,i}$','FontSize',14,'Interpreter','latex')
legend([s1,s2,s3],{'i=5, j=13','i=2, j=7','mean'},'Interpreter','latex','FontSize',11);
xlim([min(relh1,relh2)-0.08 , max(relh1,relh2)+0.08])
grid on


%Similar ice
maxi1=[144.0 91.8 107.2 109.5 104.4 112.5 102.9 121.8]; %set 6
maxj1=[82.4 85.1 87.9 144.1 139.8 176.2 127.5 133.7]; %set 9

maxi2=[191.4 154.8 211.9 227.9 150.4 152.1 206.6 142.0]; %set 7
maxj2=[180.3 183.7 213.4 180.7 195.7 201.4 166.0 133.6]; %set 8

maxi3=44.0; %set 1
maxj3=63.2; %set 12

vi1=5.90; %set 6
vj1=2.68; %set 9
vi2=4.87; %set 7
vj2=5.33; %set 8
vi3=6.08; %set 1
vj3=6.93; %set 12

relx1=maxi1./maxj1;
relx2=maxi2./maxj2;
relx3=maxi3/maxj3;
relv1=vi1/vj1;
relv2=vi2/vj2;
relv3=vi3/vj3;
x1=relv1*ones(length(maxi1),1);
x2=relv2*ones(length(maxi2),1);
x3=relv3;


figure(2)
s1=scatter(x1,relx1,'+k'); % 95% Confidence Interval: 0.9886  0.25 (0.739 to 1.24)
hold on
s2=scatter(x2,relx2,'*k'); % 95% Confidence Interval: 0.9987  0.137 (0.862 to 1.14)
%scatter(x3,relx3,'xg')
s3=scatter(x1(1),mean(relx1),'kx','SizeData',300);
scatter(x2(1),mean(relx2),'kx','SizeData',300)
title('Similar ice thickness')
xlabel('$\mu_{speed,i}/\mu_{speed,j}$','FontSize',14,'Interpreter','latex')
ylabel('$\hat{x}_{max,1h,i}/\hat{x}_{max,1h,i}$','FontSize',14,'Interpreter','latex')
legend([s1,s2,s3],{'i=6, j=9','i=7, j=8','mean'},'Interpreter','latex','FontSize',11);
xlim([min(relv1,relv2)-0.35 , max(relv1,relv2)+0.35])
grid on

