% Start thhree_param_exp.m ------------------------------------------------

% !!!This plot is always ran by another script!!!

RMSE=zeros(N+1,1); %creating vector for Root-Mean-Square Error
a_i=zeros(N+1,1); %Vector of weight parameters a
l1=zeros(N+1,1); %Vector of lambda_1 parameters
l2=zeros(N+1,1); %Vector of lambda_2 parameters
l2(1)=N/(sum(dataset)); %Creating first element. a_i(1)=l1(1)=0

for i=1:N
    a_i(i+1)=i/N;
    l1(i+1)=i/(sum(dataset(1:i)));
    l2(i+1)=(N-i)/(sum(dataset(i:end)));
end

F=zeros(N,N+1); %Fitted cumulative probability for each element in
                %dataset for all possible divisions of the dataset
for i=1:N
    %Each column represent one "set" of parameters. Each row gives F for
    %the same element in "dataset" represented by different parameters. 
    F(i,:)=a_i.*(1-exp(-l1*dataset(i)))+(1-a_i).*(1-exp(-l2*dataset(i)));
end

y1=-log(1-F); %Value in probability paper for estimated points
y2=-log(1-p_i); %Value in probability paper for measured points

for i=1:N+1
    RMSE(i)=sqrt(sum((y2'-y1(:,i)).^2)/N); %Root-Mean-Square Error
end

target=min(RMSE); %Lowest value in RMSE
for i=1:N+1
    if RMSE(i)==target %Find where the lowest RMSE is located
        nr=i;
        break
    end
end

% The set of parameters that give the lowest RMSE:
a=a_i(nr);
lambda1=l1(nr);
lambda2=l2(nr);

% Plotting the 3 parameter exp. distr and the dataset in exp. prob. paper:
x=0:1:max(dataset)*1.2;
F_fit=a*(1-exp(-lambda1*x))+(1-a)*(1-exp(-lambda2*x));
yy=-log(1-F_fit);
scatter(dataset,y2,'x')
hold on
plot(x,yy,'Color',0.0*[1 1 1])
title('3-parameter exponential distribution')
xlabel('y')
ylabel('-ln(1-p)')

% Least square line (1 parameter exponential, for comparison):
m=dataset\y2.'; %solve for slope, zero intercept
yhat=m*[0 dataset(end)]; %evaluate over same range from origin
plot([0 dataset(end)],yhat,'k-') %plot fitted line


% Most probable largest value during the time series:
n_data=length(dataset);
n_hour=60*n_data/((stop-start)*0.5);%loads per hour

%Initial values. Could have been set higher, but the script is fast anyways
F=0;
x=0;

while F<1-(1/n_data)
    x=x+0.1;
    F=a*(1-exp(-lambda1*x))+(1-a)*(1-exp(-lambda2*x));
end

% Coefficient of Determination:
F_fit=a*(1-exp(-lambda1*dataset))+(1-a)*(1-exp(-lambda2*dataset));
yy=-log(1-F_fit);
y_bar=mean(y2);
SSres=sum((y2-yy.').^2);
SStot=sum((y2-y_bar).^2);
R_squared=1-(SSres/SStot);

% Estimated most probable largest value during the analyzed time series:
x_max=x;

% End thhree_param_exp.m --------------------------------------------------